/* Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator */
/* From input file "fung.pas" */


#include <p2c/p2c.h>


#define FUNG_G
#include "fung.h"


boolean pnor = true;
uchar OUTFILE = 1;
Char _c08[8] = "       ";
double PI = 3.14159265358979;
short NTREP = 1;
double maxreal = 1.7e38;
short maxinteger = 32767;
long maxlongint = 2147483647L;
unsigned short maxword = 65535L;


Void _spline(x, y, n, k)
double **x;
double **y;
short n, k;
{
  short m, j;
  double u, TEMP;

  if (n <= 2)
    _error("less than three points in spline");

  m = n - 1;
  _spd[0] = (*x)[1] - (*x)[0];
  _spc[1] = ((*y)[1] - (*y)[0]) / _spd[0];
  for (j = 2; j <= m; j++) {
    _spd[j-1] = (*x)[j] - (*x)[j-1];
    _spb[j-1] = 2 * (_spd[j-2] + _spd[j-1]);
    _spc[j] = ((*y)[j] - (*y)[j-1]) / _spd[j-1];
    _spc[j-1] = _spc[j] - _spc[j-1];
  }
  _spb[0] = -_spd[0];
  _spb[n-1] = -_spd[n-2];
  _spc[0] = 0.0;
  _spc[n-1] = 0.0;
  if (n > 3) {
    _spc[0] = _spc[2] / ((*x)[3] - (*x)[1]) - _spc[1] / ((*x)[2] - (*x)[0]);
    _spc[n-1] = _spc[n-2] / ((*x)[n-1] - (*x)[n-3]) -
		_spc[n-3] / ((*x)[n-2] - (*x)[n-4]);
    TEMP = _spd[0];
    _spc[0] = _spc[0] * (TEMP * TEMP) / ((*x)[3] - (*x)[0]);
    TEMP = _spd[n-2];
    _spc[n-1] = _spc[n-1] * (TEMP * TEMP) / ((*x)[n-4] - (*x)[n-1]);
  }
  for (j = 2; j <= n; j++) {
    u = _spd[j-2] / _spb[j-2];
    _spb[j-1] -= u * _spd[j-2];
    _spc[j-1] -= u * _spc[j-2];
  }
  _spc[n-1] /= _spb[n-1];
  for (j = n - 2; j >= 0; j--)
    _spc[j] = (_spc[j] - _spd[j] * _spc[j+1]) / _spb[j];
  _spc1[n-1][k-1] = ((*y)[n-1] - (*y)[m-1]) / _spd[m-1] +
		    _spd[m-1] * (_spc[m-1] + 2 * _spc[n-1]);
  for (j = 0; j <= m - 1; j++) {
    _spc1[j]
      [k-1] = ((*y)[j+1] - (*y)[j]) / _spd[j] - _spd[j] * (_spc[j+1] + 2 * _spc[j]);
    _spc3[j][k-1] = (_spc[j+1] - _spc[j]) / _spd[j];
    _spc2[j][k-1] = 3 * _spc[j];
  }
  _spc2[n-1][k-1] = 3 * _spc[n-1];
  _spc3[n-1][k-1] = _spc3[n-2][k-1];
}  /*fin de calculo de los coeficientes*/


double _fSPLINEREALREAL(x, ax, ay, n, k)
double x;
double **ax;
double **ay;
short n, k;
{
  short j = 1;
  double h;

  while (j <= n && x >= (*ax)[j-1])   /*hallar tramo*/
    j++;
  if (j == 1 || j > n + 1) {
    if (x > (*ax)[j-1])
      _error("argument out of range in SPLINE function");
  }
  j--;
  h = x - (*ax)[j-1];
  return ((*ay)[j-1] + h * (_spc1[j-1]
			    [k-1] + h * (_spc2[j-1]
					 [k-1] + h * _spc3[j-1][k-1])));
}


double _fPOLYGREALREAL(x, ax, ay, n)
double x;
double **ax;
double **ay;
short *n;
{
  short j = 1;

  while (j <= *n && x >= (*ax)[j-1])
    j++;
  if (j == 1)
    return ((*ay)[0]);
  else if (j > *n)
    return ((*ay)[*n - 1]);
  else {
    /*if(j=1) or (j>n) then _error('argument out of range in POLYG function');*/
    return ((*ay)[j-2] + ((*ay)[j-1] - (*ay)[j-2]) / ((*ax)[j-1] - (*ax)[j-2]) *
			 (x - (*ax)[j-2]));
  }
}


double _fSTAIRREALREAL(x, ax, ay, n)
double x;
double **ax;
double **ay;
short *n;
{
  short j = 1;

  while (j <= *n && x >= (*ax)[j-1])
    j++;
  if (j == 1 || j > *n)
    _error("argument out of range in STAIR function");
  return ((*ay)[j-2]);
}


double _fFREQREALREAL(ax, ay, n, rn)
double **ax;
double **ay;
short *n, rn;
{
  short j = 1;
  double r;

  r = (*ay)[*n - 1] * _randreal();
  while (r > (*ay)[j-1])
    j++;
  return ((*ax)[j-1]);
}


double _fDISCREALREAL(x, ax, ay, n)
double x;
double **ax;
double **ay;
short *n;
{
  short j = 1;

  while (j != *n && x != (*ax)[j-1])
    j++;
  if (j > *n)
    _error("argument out of range in DISC function");
  return ((*ay)[j-1]);
}


/******************************************************_INTIGRAFA*****/
Void _intigrafa(_xa, _y, _n, _k, tip, name)
Char (**_xa)[13];
double **_y;
short *_n, _k, tip;
Char *name;
{
  /*grafico funciones XY con X no REAL*/
  double *_x;
  short FORLIM;

  _x = (double *)Malloc(sizeof(_txx));
  _xaa = (Char(*)[13])Malloc(sizeof(_txxa));
  FORLIM = *_n;
  for (_i = 1; _i <= FORLIM; _i++) {
    _x[_i-1] = _i;
    strcpy(_xaa[_i-1], (*_xa)[_i-1]);
  }
  /*pasar X no REAL a REALES 1,2,3,..*/
  _bnoreal = true;
  _intigraf(&_x, _y, _n, 1, tip, name);
  Free(_x);
}


/* Local variables for _intigraf: */
struct LOC__intigraf {
  double **_x;
  double **_y;
  short *_n, tip;
  double _xsmin, _xsmax, _ysmin, _ysmax;
  short _kx, _ky;
  boolean firstfreq;
} ;

/* * Quitado todo _INTIGRAPH hasta probat RATON */
/******************************************************_MAXYMIN*******/
Local Void _maximin(LINK)
struct LOC__intigraf *LINK;
{
  /*halla maximos y minimos*/
  /*Hallar maximos y minimos de los valores tabulados*/
  short _i, FORLIM;

  LINK->_xsmin = 1.7e38;
  LINK->_xsmax = -1.7e38;
  LINK->_ysmin = 1.7e38;
  LINK->_ysmax = -1.7e38;
  FORLIM = *LINK->_n;
  for (_i = 0; _i <= FORLIM - 1; _i++) {
    if ((*LINK->_x)[_i] < LINK->_xsmin)   /*deberian ser los extremos*/
      LINK->_xsmin = (*LINK->_x)[_i];
    if ((*LINK->_x)[_i] > LINK->_xsmax)
      LINK->_xsmax = (*LINK->_x)[_i];
    if ((*LINK->_y)[_i] < LINK->_ysmin)
      LINK->_ysmin = (*LINK->_y)[_i];
    if ((*LINK->_y)[_i] > LINK->_ysmax)
      LINK->_ysmax = (*LINK->_y)[_i];
  }

  /*Para ajustar valores si no esta incluido el origen de coordenadas*/
  if (LINK->_ysmin >= 0)
    LINK->_kx = 0;
  else
    LINK->_kx = 1;
  if (LINK->_xsmin >= 0)
    LINK->_ky = 0;
  else
    LINK->_ky = 1;

  if (LINK->tip == 5 || LINK->tip == 4)
    LINK->_ysmin = 0.0;
  /*para tipo FREQ siempre minimo es cero*/

}

/******************************************************_TRAZEJE*******/
Local Void _trazeje(LINK)
struct LOC__intigraf *LINK;
{
  /*traza ejes*/
  /*Trazar recuadro*/
  /* Quitado hasta probar raton */

}

/****************************************************_CONVACFR*******/
/*convertir acumuladas en frecuencias; para FREQ INTEGER guardar
valores enteros y pasarlos a x^ y^ */
Local Void _convacfr(LINK)
struct LOC__intigraf *LINK;
{
  short _i;

  /*if tipo=5 then guardar valores enteros convertilos y pasar a _x^*/
  /*calcular las diferencias*/
  for (_i = *LINK->_n; _i >= 2; _i--)
    (*LINK->_y)[_i-1] -= (*LINK->_y)[_i-2];
  LINK->firstfreq = false;
}

/****************************************************_CONVFRAC*******/
/*reconvertir frecuencias en acumuladas;para FREQ INTEGER pasar los x^
 convertidos al arreglo de enteros */
Local Void _convfrac(LINK)
struct LOC__intigraf *LINK;
{
  short _i, FORLIM;

  FORLIM = *LINK->_n;
  /*if tipo=5 then guardar y transferir valores enteros*/
  /*calcular las acumuladas*/
  for (_i = 2; _i <= FORLIM; _i++)
    (*LINK->_y)[_i-1] += (*LINK->_y)[_i-2];
}


/******************************************************_INTIGRAF******/
Void _intigraf(_x_, _y_, _n_, _k, tip_, name)
double **_x_;
double **_y_;
short *_n_, _k, tip_;
Char *name;
{
  struct LOC__intigraf V;

  /* Quita hasta probar raton
     const barfre:fillpatterntype=($AA,$55,$AA,$55,$AA,$55,$AA,$55);*/

  /******************************************comienzo del _intigraf*/

  V._x = _x_;
  V._y = _y_;
  V._n = _n_;
  V.tip = tip_;
}  /*de _intigraf*/


/*****************************************VENTANA.REGISTRA****/
Void Ventana_Registra(Self)
Ventana *Self;
{
  Self->ancho = Self->xd - Self->xi;
  Self->alto = Self->yd - Self->yi;
  VentanaActiva = Self;
}


Void Ventana_Borde(Self)
Ventana *Self;
{
  uchar i, FORLIM;

  Self->ConBorde = true;
  /*LINUX TextBackground(ColorF); TextColor(Black); */
  clrscr();
  if (Self->yd > 24)
    Self->yd = 24;
  /*LINUX */
  gotoxy(1, 1);
  printf("Running model: %s", P_argv[0]);
  /*LINUX Window(xi,yi,xd,yd+1);
  GotoXY(1,1); */
  gotoxy(Self->xi, Self->yi);
  /*LINUX Write(chr(218)); For i:=1 to ancho-1 do Write(Chr(196)); Write(chr(191));*/
  putchar('.');
  FORLIM = Self->ancho;
  for (i = 1; i <= FORLIM - 1; i++)
    putchar('-');
  putchar('.');
  FORLIM = Self->alto;
  for (i = 1; i <= FORLIM - 1; i++) {
    gotoxy(Self->xi, Self->yi + i);
    putchar('|');
    gotoxy(Self->xi + Self->ancho, Self->yi + i);
    putchar('|');
  }
  /*LINUX GotoXY(1,i); Write(chr(179)); GotoXY(ancho+1,i); Write(chr(179));*/
  /*LINUX GotoXY(xi+1,yi+alto+1);*/
  gotoxy(Self->xi, Self->yi + Self->alto);
  putchar('.');
  FORLIM = Self->ancho;
  for (i = 1; i <= FORLIM - 1; i++)
    putchar('_');
  putchar('.');
  /*LINUX TextColor(ColorT);
  Window(xi,yi,xd,yd);*/
}  /*Borde*/


Void Ventana_MainPort(Self, ColF, ColT)
Ventana *Self;
uchar ColF, ColT;
{
  Self->ConBorde = false;
  Self->ColorF = ColF;
  Self->ColorT = ColT;
  /*LINUX TextBackground(ColorF);  TextColor(ColorT);
  Window(1,1,80,24); */
  Self->xi = 1;
  Self->yi = 1;
  Self->xd = 80;
  Self->yd = 24;
  Ventana_Registra(Self);
}


Void Ventana_MenuPort(Self, PosX, PosY, Largo, n, ColF, ColT)
Ventana *Self;
uchar PosX, PosY, Largo, n, ColF, ColT;
{
  Self->xi = PosX;
  Self->yi = PosY;
  Self->xd = PosX + Largo + 4;
  Self->yd = PosY + n + 3;
  Self->ColorF = ColF;
  Self->ColorT = ColT;
  /*LINUX TextBackground(ColorF);  TextColor(ColorT);
  Window(xi,yi,xd,yd);*/
  Ventana_Registra(Self);
  Ventana_Borde(Self);
}


Void Ventana_Muestra(Self)
Ventana *Self;
{
  /*LINUX TextBackground(ColorF);  TextColor(ColorT);
  Window(xi,yi,xd,yd);*/
  clrscr();
  if (Self->ConBorde)
    Ventana_Borde(Self);
}


Void MenuS_Init(Self, nTO, nO, tOp, pX, pY, CF, CT)
MenuS *Self;
uchar nTO, nO, tOp, pX, pY, CF, CT;
{
  Self->TotOpciones = nTO;
  if (nO <= Self->TotOpciones)
    Self->NumOpciones = nO;
  else
    Self->NumOpciones = nTO;
  Self->TaMaxOps = tOp;
  Self->PosMenuX = pX;
  Self->PosMenuY = pY;
  Self->laAnterior = VentanaActiva;
  Ventana_MenuPort(&Self->laVentana, pX, pY, tOp, nO, CF, CT);
}


Void MenuS_DefiOpcios(Self, DirOpcios)
MenuS *Self;
Opcion *DirOpcios;
{
  Self->elMenu = DirOpcios;
}


Void MenuS_OutPalabraM(Self, Cual)
MenuS *Self;
uchar Cual;
{
  Opcion *WITH1;
  Char STR1[256];

  /*LINUX GotoXY(laVentana.xi+3,laVentana.yi+Cual+2);*/
  gotoxy(Self->laVentana.xi + 3, Self->laVentana.yi + Cual + 1);
  WITH1 = &Self->elMenu[Cual-1];
  printf("%.*s", WITH1->Resal - 1, WITH1->NameOp);
  /*CTa:=TextAttr and 15; .guarda color texto actual.
  TextColor(Red);*/
/*PROB*/ set_reversevideo();
  putchar(WITH1->NameOp[WITH1->Resal - 1]);
/*PROB*/ set_normalvideo();
  /*TextColor(CTa);*/
  fputs(strsub(STR1, WITH1->NameOp, WITH1->Resal + 1,
	       strlen(WITH1->NameOp) - WITH1->Resal), stdout);
}  /*OutPalabraM*/


Void MenuS_ResalCuadro(Self, Cual)
MenuS *Self;
uchar Cual;
{
  /*TextBackground(White); TextColor(Black);*/
  MenuS_OutPalabraM(Self, Cual);
  /*TextBackground(laVentana.ColorF);
  TextColor(laVentana.ColorT);*/
  gotoxy(Self->laVentana.xi + Self->elMenu[Cual-1].Resal + 2,
	 Self->laVentana.yi + wherey);
}  /*ResalCuadro*/


Void MenuS_Resalta(Self, CualSi, CualNo)
MenuS *Self;
uchar CualSi, CualNo;
{
  MenuS_OutPalabraM(Self, CualNo);
  MenuS_ResalCuadro(Self, CualSi);
}


uchar MenuS_Selec(Self)
MenuS *Self;
{
  uchar Seleccionada = 1;
  uchar i;
  Char Tecla;
  boolean Salida = false;
  /*LINUX*/
  uchar xm, ym, FORLIM;

  FORLIM = Self->NumOpciones;
  for (i = 1; i <= FORLIM; i++)
    MenuS_OutPalabraM(Self, i);
  /*LINUX*/
  xm = wherex;
  ym = wherey + 3;
  /*LINUX
        MenuS_ResalCuadro(Self,1); */
  do {
    gotoxy(xm, ym);
    Tecla = getch();
    Tecla = toupper(Tecla);
    /*LINUX*/
    gotoxy(xm, ym);
    printf("      ");
    /*LINUX
            If {KeyPressed} Tecla=#0 then Begin
               OtraTecla:=ReadKey;
               Case OtraTecla of
               'H': {arriba}
                    If Seleccionada > 1 then
                    Begin Seleccionada:=Seleccionada - 1;
                      MenuS_Resalta(Self,Seleccionada,Seleccionada+1);
                    End; {arriba}
               'P': {abajo}
                    If Seleccionada < NumOpciones then
                    Begin Seleccionada:=Seleccionada + 1;
                      MenuS_Resalta(Self,Seleccionada,Seleccionada-1);
                    End; {abajo}
               End;
            End                         else
              If Ord(Tecla)=13 then {RETURN} Salida:=True
              else
              If (Tecla=ESC)   then {ESCAPE}
              Begin
                Seleccionada:=0;  Salida:=True;
              End
              else
              Begin
LINUX */
    i = 1;
    while (i <= Self->NumOpciones) {
      if (Tecla == Self->elMenu[i-1].NameOp[Self->elMenu[i-1].Resal - 1]) {
	/*LINUX MenuS_OutPalabraM(Self,Seleccionada);*/
	/*Desresalta*/
	Seleccionada = i;
	i = Self->NumOpciones + 1;
	Salida = true;
      } else
	i++;
    }
    /*LINUX End;*/
  } while (!Salida);
  /*LINUX*/
  return Seleccionada;
  /*LINUX If (Seleccionada>0) then MenuS_ResalCuadro(Self,Seleccionada);*/
}  /*Selec*/


Void MenuS_Retira(Self)
MenuS *Self;
{
  VentanaActiva = Self->laAnterior;
  Ventana_Muestra(VentanaActiva);
}


/*//////////////////////FIN DE LO QUE VA EN UNIT\\\\\\\\\\\\\\\\\\\*/


Void _afel(n, i, p, blk, t)
short n, i;
uchar p;
boolean blk;
double t;
{
  /*agr.a fel
                          ordenado segun t */
  if (_bt) {
    printf("ADD TO FEL EV %d IEV %d TIME %10.3f\n", n, i, t);
    if (_bftr)
      fprintf(_ftra, "ADD TO FEL EV %d IEV %d TIME %10.3f\n", n, i, t);
    _ch = getch();
  }
  _pf = (_fel *)Malloc(sizeof(_fel));
  _pf->n = n;
  _pf->i = i;
  _pf->t = t;
  _pf->evp = p;
  if (blk)
    _pf->su = true;
  else
    _pf->su = false;
  _pf->p = NULL;
  if (_ff == NULL) {
    _ff = _pf;
    _pf->p = NULL;
    return;
  }
  _ps = _ff;
  _bo = true;
  while (_ps != NULL && _bo) {
    if (t < _ps->t)
      _bo = false;
    else {
      _py = _ps;
      _ps = _ps->p;
    }
  }
  _pf->p = _ps;
  if (_ps == _ff)
    _ff = _pf;
  else
    _py->p = _pf;
}


Void _error(s)
Char *s;
{
  printf("Execution error. Press any key. *********************\n");
  puts(s);
  _ch = getch();
  _Escape(0);
}


Void _verpsos()
{
  /*si es PS poner parametros; si es SO, _bout false*/
  /*LINUX*/
  _detect = 0;
  _grm = 0;
  _posparmbgi = 1;
  /*LINUX
if paramcount>0 then
if (copy(paramstr(1),1,3)='/ps') or (copy(paramstr(1),4,6)='/ps')
or (copy(paramstr(1),1,3)='/PS') or (copy(paramstr(1),4,6)='/PS')
then
begin _detect:=0; {VGA;} _grm:=0; {VGAHI;} _posparmbgi:=2 end; */

  _bout = true;
  /*LINUX
if (copy(paramstr(1),1,3)='/so') or (copy(paramstr(1),4,6)='/so')
or (copy(paramstr(1),1,3)='/SO') or (copy(paramstr(1),4,6)='/SO')
   then _bout:=false;*/
}


Void block(n, b)
short n;
boolean *b;
{
  /*suspende evento n */
  _fel *pfa;

  *b = true;
  pfa = _ff;
  while (pfa != NULL) {
    if (pfa->su == false && pfa->n == n)
      pfa->su = true;
    pfa = pfa->p;
  }
}


Void deblock(n, b)
short n;
boolean *b;
{
  _fel *pfa;

  if (!*b)
    return;
  *b = false;
  pfa = _ff;
  while (pfa != NULL) {
    if (pfa->su == true && pfa->n == n)
      pfa->su = false;
    pfa = pfa->p;
  }
}


Void _encsal()
{
  /*LINUX clrscr;*/
  fprintf(_ars, "%s\n", TITLE);
  /*LINUX writeln(_ars,'Time ',time:10:2,' Time Stat.',_t:10:2,*/
/*LINUX Correccion Y2000*/ _an-=100; _an+=2000;
  fprintf(_ars,
    "Time %10.2f Time Stat.%10.2f  Replication %4d  %2u/%2u/%4u %2uh %2um %2us\n",
    TIME, _t, NREP, _dia, _mes, _an, _ho, _mini, _seg);
  fprintf(_ars, "Elapsed time %2ldh %2ldm %2ld.%lds\n",
	  _dhor, _dmi, _dse, _dde);
  fprintf(_ars,
    "Nod/Ind Ant/Li #Ent Lgth   Max    Mean    Dev   MaxSt   MeanSt    Dev    T.Free\n");
}


Void _intime()
{
  /*calcula intervalo de tiempo*/
  long dh, st, s1, s2, lhoi, lmii, lsei, ldei, lhof, lmif, lsef, ldef;

  lhoi = _hoi;
  lmii = _mii;
  lsei = _sei;
  ldei = _dei;
  lhof = _hof;
  lmif = _mif;
  lsef = _sef;
  ldef = _def;
  dh = lhof - lhoi;
  if (dh < 0)
    dh += 24;
  st = dh * 360000L + (lmif - lmii) * 6000 + (lsef - lsei) * 100 + ldef - ldei;
  _dhor = st / 360000L;
  s1 = st - _dhor * 360000L;
  _dmi = s1 / 6000;
  s2 = s1 - _dmi * 6000;
  _dse = s2 / 100;
  _dde = s2 - _dse * 100;
}


Void _inisinc()
{
  /*inicializar proceso busqueda sincronizados*/
  _pc = _fs;
  _sf = false;
  _bs = false;
  sync = true;
  _aas = true;
  _plas = _pc->p1;
}


Void _ililisin()
{
  /*eliminar ap. a mensaje sincronizado*/
  _as = _pc;
  _pc = _pc->p2;
  Free(_as);
}


double rnd(i)
short i;
{
  /*numeros aleatorios semilla i */
  /*LINUX var r:longint; a mano*/
  int r;

  r = rn[i-1];
  r *= 65539L;
  if (r < 0)
    r += 2147483648;
  rn[i-1] = r;
  return (r / 2147483647.0);
}


Void inisem()
{
  rn[0] = 29999;
  rn[1] = 63115L;
  rn[2] = 37357L;
  rn[3] = 68803L;
  rn[4] = 23565;
  rn[5] = 87457L;
  rn[6] = 43731L;
  rn[7] = 79369L;
  rn[8] = 39819L;
  rn[9] = 52341L;
}


Void _leerenc(_ardbase)
FILE *_ardbase;
{
  /*leer encab. de archivo DBASE*/
  short numdesc, i, j;
  Char buff[180];

  /*Lectura de los registros de informacion */
/* p2c: fung.pas, line 689:
 * Note: Can't interpret name argument in RESET [180] */
  rewind(_ardbase);   /*apuntar al primero y poner de largo 1*/

  /*lee de archivo descr., en area _ledbase, 32 registros de largo 1
    en resul quedan la cantidad realmente leida*/
/* p2c: fung.pas, line 693: Note: Can't interpret size in BLOCKREAD [174] */
  _resul = fread(&_ledbase, 1, 32, _ardbase);
  _lonreg = _ledbase.byrec;
  /* writeln('Fecha ultima actualizacion     ',
             _ledbase.fecha[1],' ',_ledbase.fecha[2],' ',_ledbase.fecha[3]);


   writeln('Numero de registros            ',_ledbase.numreg-1);
   writeln('Numero de bytes en enc.        ',_ledbase.bytenc);
   writeln('Numero de bytes en el registro ',_lonreg);
   writeln;
  */
  numdesc = (_ledbase.bytenc - 1) / 32 - 1;
      /*numero de descriptores de campos*/

  for (i = 1; i <= numdesc; i++) {
    _resul = fread(&_ledbase, 1, 32, _ardbase);   /*leer descriptor de campo*/
    _pdesc = (_des *)(&_ledbase);   /*aputador a lo leido  ? */
    *_nomdbase = '\0';
    for (j = 0; j <= 10; j++) {   /*recoger nombre*/
      sprintf(_nomdbase + strlen(_nomdbase), "%c", _pdesc->nomb[j]);
/* p2c: fung.pas, line 711:
 * Note: Possible string truncation in assignment [145] */
    }
    /*  write('Nombre del campo ',_nomdbase);
      write('  Tipo ',_pdesc^.tipo);
      writeln('  Largo ',_pdesc^.largo);
    */
  }
/* p2c: fung.pas, line 708: Note: Can't interpret size in BLOCKREAD [174] */

  /*writeln;
_ch:=readkey; */

  _resul = fread(buff, 1, 2, _ardbase);   /*quitar fin reg y linefeed*/
}


Void _copystdb()
{
  /*copia struc.DBASE _ardbase a _ardbaseu; DBUPDATE*/
  unsigned short numdesc, i;
  Char buff[128];

/* p2c: fung.pas, line 727: Note: Can't interpret size in BLOCKREAD [174] */
  _resul = fread(&_ledbase, 1, 32, _ardbase);   /*leer desc.de registro*/
/* p2c: fung.pas, line 728:
 * Note: Can't interpret size in BLOCKWRITE [174] */
  _resul = fwrite(&_ledbase, 1, 32, _ardbaseu);   /*escr desc.de registro*/
  _lonreg = _ledbase.byrec;
  numdesc = (_ledbase.bytenc - 1) / 32 - 1;   /*numero de desc. de campos*/
  for (i = 1; i <= numdesc; i++) {
    _resul = fread(&_ledbase, 1, 32, _ardbase);   /*leer descriptor de campo*/
/* p2c: fung.pas, line 734:
 * Note: Can't interpret size in BLOCKWRITE [174] */
    _resul = fwrite(&_ledbase, 1, 32, _ardbaseu);
	/*escr descriptor de campo*/
  }
/* p2c: fung.pas, line 733: Note: Can't interpret size in BLOCKREAD [174] */
  _resul = fread(buff, 1, 2, _ardbase);   /*quitar fin reg y linefeed*/
  _resul = fwrite(buff, 1, 2, _ardbaseu);   /*poner  fin reg y linefeed*/
}


/*****************************************************************/

/*funciones aleatorias y aritmeticas*/
double expo_(v, i)
double v;
short i;
{
  if (v < 0)
    _error("negative parameter in EXPO");
  return (-v * log(rnd(i)));
}


double unif(vi, vs, i)
double vi, vs;
short i;
{
  if (vi > vs)
    _error("parameters in UNIF not in order");
  return (vi + (vs - vi) * rnd(i));
}


short unifi(a, b, i)
short a, b, i;
{
  double y, z;

  if (b < a)
    _error("parameters in UNIFI not in order");
  z = b - a + 1.0;
  y = a;
  return ((long)(y + rnd(i) * z));
}


double tria(a, b, c, i)
double a, b, c;
short i;
{
  double r, ca, ba, cb;

  r = rnd(i);
  ca = c - a;
  ba = b - a;
  cb = c - b;
  if (ba <= 0 || cb <= 0)
    _error("parameters of TRIA not in order");
  if (r < ba / ca)
    return (a + sqrt(r * ba * ca));
  else
    return (c - sqrt(cb * ca * (1 - r)));
}


double norm(vm, d, i)
double vm, d;
short i;
{
  /* numero de dist. normal */
  double u, v, x, z;

  if (d < 0)
    _error("deviation of GAUSS or NORM negative");

  do {   /*metodo de la relacion (Ripley:Stocasting Simulation)*/
    u = rnd(i);
    v = 0.8578 * (2 * rnd(i) - 1);
    x = v / u;
    z = 0.25 * x * x;
  } while (z >= 1 - u && (z > 0.259 / u + 0.35 || z > -log(u)));
  return (d * x + vm);
}


double gauss(vm, d, i)
double vm, d;
short i;
{
  /* numero positivo de dist.normal */
  double v;

  do {
    v = norm(vm, d, i);
  } while (v < 0);
  return v;
}


double erlg(v, k, i)
double v;
short k, i;
{
  /* erlang suma k exp. de media v */
  double p = 0.0;
  short j;

  if (v < 0 || k <= 0)
    _error("parameters in ERLG not positive");
  /* p:=1.0;
   for j:=1 to k do p:=p*rnd(i);
   erlg:=-ln(p)*v */
  for (j = 1; j <= k; j++)
    p -= v * log(rnd(i));
  return p;
}


double weibull(e, f, i)
double e, f;
short i;
{
  /*Weisbull escala e, forma f*/
  /*para tasa de fallas a*t**b poner e=b+1; f=(e/a)**(1/e)
    donde t es el tiempo y ** significa "elevado a"      */
  if (e < 0 || f <= 0)
    _error("parameters in WEIBULL not positive");
  return (1 / f * log(-e * log(rnd(i))));
}


short Poisson(m, i)
double m;
short i;
{
  /*Poisson*/
  /*se toman productos de n numeros r hasta que su producto
    se haga menor que exp(-media)  */
  short k = 0;
  double p, h;

  if (m < 0)
    _error("parameter in POISSON not positive");
  h = exp(-m);
  p = rnd(i);
  while (p >= h) {
    p *= rnd(i);
    k++;
  }
  return k;
}


double lognorm(m, s, i)
double m, s;
short i;
{
  /*lognormal con media m
    y parametro de forma s. Se toma l:=m*exp(z) siendo z de
    distribucion normal media 0 y desviacion s.
    N.A.J. Hastings and J.B. Peacock. Statistical  Distributions.
    John Wiley & Sons 1974.*/
  if (s <= 0)
    _error("parameter of LOGNORM negative");
  return (m * exp(norm(0.0, s, i)));
}


double gama(m, d, i)
double m, d;
short i;
{  /*metodo de Fishman, Johnk y Tadikamalla*/
  /*funcion gama*/
  /*LINUX gamma exite*/
  /*"suma" de a exponenciales de media b*/
  /* b=desv*desv/media  a=(media* media)/(desv*desv)  */
  double u1, u2, b1, p, b, a, GAMM;
  short a1, j;

  b = d * d / m;
  a = m * m / (d * d);
  if (a <= 0)
    _error("non positive parameter in GAMMA ");
  if (a > 0 && a < 1) {
    do {
      u1 = exp(log(rnd(i)) / a);
      u2 = exp(log(rnd(i)) / (1 - a));
    } while (u1 + u2 > 1);
    GAMM = u1 / (u1 + u2) * -log(rnd(i)) * b;
    return GAMM;
  }
  if (a >= 1 && a < 5) {
    /*LINUX a1:=round(int(a)); b1:=a-a1;*/
    a1 = (long)a;
    b1 = a - a1;
    do {
      p = 1.0;
      for (j = 1; j <= a1; j++)
	p *= rnd(i);
      u1 = -(a / a1) * log(p);
    } while (rnd(i) > exp(b1 * log(u1 / a)) * exp(b1 * (1 - u1 / a)));
    GAMM = u1 * b;
    return GAMM;
  }
  /*LINUX begin   j:=round(int(a));*/
  j = (long)a;
  /*LINUX if rnd(1)>a-int(a) then gamm:=erlg(b,j,i)*/
  if (rnd(1) > a - (long)a)
    GAMM = erlg(b, j, i);
  else
    GAMM = erlg(b, j + 1, i);
  /*es a>=5 */
  return GAMM;
}


double beta(a, b, i)
double a, b;
short i;
{
  /*funcion beta*/
  double g1;

  if (a <= 0 || b <= 0)
    _error("non positive parameter in BETA ");
  g1 = gama(1.0, a, i);
  return (g1 / (g1 + gama(1.0, b, i)));
}


boolean ber(p, i)
double p;
short i;
{
  /* Bernoulli true si rnd(i)<p */
  if ((unsigned)p > 1.0)
    _error("argument out of range in BER");
  if (rnd(i) < p)
    return true;
  else
    return false;
}


double min(x, y)
double x, y;
{
  if (x <= y)
    return x;
  else
    return y;
}


double max(x, y)
double x, y;
{
  if (x >= y)
    return x;
  else
    return y;
}


short mini(x, y)
short x, y;
{
  if (x <= y)
    return x;
  else
    return y;
}


short maxi(x, y)
short x, y;
{
  if (x >= y)
    return x;
  else
    return y;
}


double modul(x, m)
double x, m;
{
  double TEMP;

  if (m == 0)
    _error("null module in MODUL");
  modf(x, &TEMP);
  return (x - TEMP * m);
}



/* End. */
