/* Header for module pxgraph, generated by p2c 1.21alpha-07.Dec.93 */
#ifndef GRAPH_H
#define GRAPH_H


#ifdef GRAPH_G
# define vextern
#else
# define vextern extern
#endif


/*pxgraph.h
  LINUX

  Encabezados para Programas Pascal para Lib xgraph

  Primera version: Marta Sananes
  Segunda version: Rafael Tineo

  Ultima modificacion: MARTA 17.09.1999
  LINUX  modificacion: MARTA 01.05.2000
*/

#define MaxWindows      20
#define MAXCOLORS       16

/* Los colores */ 

#define Black           0
#define Blue            1
#define Green           2
#define Cyan            3
#define Red             4
#define Magenta         5
#define Brown           6
#define LightGray       7
#define DarkGray        8
#define LightBlue       9
#define LightGreen      10
#define LightCyan       11
#define LightRed        12
#define LightMagenta    13
#define Yellow          14
#define White           15    


/* Los tipos de linea */ 

#define solidln         0
#define dottedln        2   /*no hay correspondiente*/
#define centerln        2   /*idem*/
#define dashedln        1
#define userBitln       0   /*no hay correspondiente*/
#define normwidth       1
#define thickwidth      3

#define SolidLn         0
#define DottedLn        2   /*no hay correspondiente*/
#define CenterLn        2   /*idem*/
#define DashedLn        1
#define UserBitLn       0   /*no hay correspondiente*/
#define NormWidth       1
#define ThickWidth      3 

/* Los tipos de ajuste */  

#define lefttext        0
#define centertext      1
#define righttext       2
#define bottomtext      0
#define toptext         1

#define LeftText        0
#define CenterText      1
#define RightText       2
#define BottomText      0
#define TopText         1 

/* Los tipos de orientacion */
 
#define horizdir        0
#define vertdir         1  

#define HorizDir        0
#define VertDir         1  

/* Los tipos de Fonts */
 
#define defaultfont     0
#define triplexfont     1
#define smallfont       2
#define sanseriffont   3
#define gothicfont      4   

/* Patrones de relleno */
 
#define FillSolid       0   /* Hay diferencia en los patrones de relleno */
#define FillTiled       1   /* con respecto al TURBO pascal */
#define FillStippled    2
#define FillOpaqueStippled  3
 
#define FillSolid_      0   /* Hay diferencia en los patrones de relleno */
#define FillTiled_      1   /* con respecto al TURBO pascal */
#define FillStippled_   2
#define FillOpaqueStippled_  3
 
/* Tipos de evento */
 
#define VisibilityEvent  1
#define KeyboardEvent   2
#define MouseEvent      3      

/* Tipos de visibilidad */
 
#define TotalVisibility  0
#define PartialVisibility  1
#define NoVisibility    2
 
/* Tipos de evento de raton */
 
#define ButtonDown      1
#define ButtonUp        2
#define ButtonMotion    3
 
/* Tipos de cursor para raton CursorType*/
 
#define TargetCursor    128
#define TcrossCursor    130
#define Left_ptrCursor  132
#define WatchCursor     150
#define XtermCursor     152
 
 
/*  tpIOResult: integer; */    
vextern short wherex, wherey, wherex_, wherey_;
vextern boolean reversevideo;

typedef struct EventStructure {
  short nwindow;   /*Ventana en la cual ocurrio el evento*/
  short x;   /*Coordenada x del raton*/
  short y;   /*Coordenada y del raton*/
  short button;   /*Boton presionado del raton*/
  short key;   /*Tecla presionada*/
  short visibility;   /*Tipo de visibilidad registrada*/
  short mouseevent;   /*Tipo de Evento de raton Registrado*/
} EventStructure;


extern Void Arc PP((int x, int y, int StAngle, int EndAngle, int radius));
extern Void Bar PP((int x1, int y1, int x2, int y2));
extern Void Bar3D PP((int x1, int y1, int x2, int y2, int Depth, int Top));
extern Void Circle PP((int x, int y, int radius));
extern Void ClearDevice PV();
extern Void CloseGraph PV();
extern Void CloseWindow PP((int man));
extern unsigned short GetBkColor PV();
extern unsigned short GetColor PV();
extern unsigned short GetMaxColor PV();
extern unsigned short GetMaxX PV();
extern unsigned short GetMaxY PV();
extern Void InitGraph PP((int *x, int *y, Anyptr WinNamePtr));
extern short InitWindow PP((int x, int y, Anyptr WinNamePtr));
extern Void Line PP((int x1, int y1, int x2, int y2));
extern Void LineRel PP((int dx, int dy));
extern Void LineTo PP((int x, int y));
extern Void MoveRel PP((int dx, int dy));
extern Void MoveTo PP((int x, int y));
extern short NextEvent PP((int EventType, EventStructure *EventData));
extern short GetActiveWindow PV();
extern Void GetImage PP((int x1, int y1, int x2, int y2, Anyptr *BitMap));
extern short GetLastWindow PV();
extern Void OutText PP((Anyptr Texto));
extern Void OutTextXY PP((int x, int y, Anyptr Texto));
extern Void PutImage PP((int x1, int y1, Anyptr *BitMap, int BitBlt));
extern Void PutPixel PP((int x, int y, int Pixel));
extern Void Rectangle PP((int x1, int y1, int x2, int y2));
extern Void SelectWindow PP((int aWindow));
extern Void SetBkColor PP((int ColorNum));
extern Void SetColor PP((int Color));
extern Void SetFillStyle PP((int Pattern, int Color));
extern Void SetLineStyle PP((int LineStyle, int pattern, int Thickness));
extern Void SetMouseCursor PP((int tipo));
extern Void SetTextJustify PP((int Horiz, int vert));
extern Void SetTextStyle PP((int tipoFont, int Direction, int CharSize));
extern Void ThisEvent PP((int EventType, EventStructure *EventData));


#undef vextern

#endif /*PXGRAPH_H*/

/* End. */
