unit graph;
(*pxgraph.h
  LINUX

  Encabezados para Programas Pascal para Lib xgraph

  Primera version: Marta Sananes
  Segunda version: Rafael Tineo

  Ultima modificacion: MARTA 17.09.1999
  LINUX  modificacion: MARTA 01.05.2000
*)
interface

const MaxWindows = 20;
      MAXCOLORS = 16;

type
 
   EventStructure = record
      nwindow    : integer; {Ventana en la cual ocurrio el evento}
      x          : integer; {Coordenada x del raton}
      y          : integer; {Coordenada y del raton}
      button     : integer; {Boton presionado del raton}
      key        : integer; {Tecla presionada}
      visibility : integer; {Tipo de visibilidad registrada}
      mouseevent : integer; {Tipo de Evento de raton Registrado}
   end;     

procedure Arc(x, y:integer; StAngle, EndAngle, radius: word);
procedure Bar(x1, y1, x2, y2: integer);
procedure Bar3D(x1, y1, x2, y2: integer; Depth: word; Top: boolean);
procedure Circle(x, y: integer; radius: word);
procedure ClearDevice;
procedure CloseGraph;
procedure CloseWindow(man: integer);
function  GetBkColor: word;
function  GetColor: word;
function  GetMaxColor: word;
function  GetMaxX: word;
function  GetMaxY: word;
procedure InitGraph(x, y: integer; WinNamePtr: pointer); 
function  InitWindow(x,y: integer; WinNamePtr: pointer): integer;
procedure Line(x1, y1, x2, y2: integer);
procedure LineRel(dx, dy: integer);
procedure LineTo(x, y: integer);
procedure MoveRel(dx, dy: integer);
procedure MoveTo(x, y: integer);
function  NextEvent(EventType: integer; var EventData: EventStructure): integer;
function  GetActiveWindow: integer;
procedure GetImage(x1, y1, x2, y2 : integer; var BitMap : pointer ); 
function  GetLastWindow: integer;
procedure OutText(Texto: pointer); 
procedure OutTextXY(x, y: integer; Texto: pointer); 
procedure PutImage(x1, y1 : integer; var BitMap : pointer; BitBlt : word); 
procedure PutPixel(x, y: integer; Pixel: word);
procedure Rectangle(x1, y1, x2, y2: integer);
procedure SelectWindow(aWindow: integer);
procedure SetBkColor(ColorNum: word);
procedure SetColor(Color: word);
procedure SetFillStyle(Pattern, Color: word);
procedure SetLineStyle(LineStyle, pattern, Thickness: word);
procedure SetMouseCursor(tipo: word); 
procedure SetTextJustify(Horiz, vert: word);
procedure SetTextStyle(tipoFont, Direction, CharSize: word);
procedure ThisEvent(EventType: integer; var EventData: EventStructure);

implementation

end.








