/* cturbo.c

   Libreria de emulacion de rutinas de turboPascal.
   Contiene las siguientes rutinas:

*/

#define CTURBO_G
#include "cturbo.h"

/* LINUX: pasado a cturbo.h
static char gotoxy_str[15] = "";
extern short int wherex, wherey;
extern short int reversevideo; 
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

/*
 ifndef CTIPOS
 include "ctipos.h"
 endif
*/

#include <errno.h>

void clrscr()
{ printf("%c[2J", 27); 
  wherex = 1; wherey = 1;
}

void delay(x)
float x;
{ 
   clock_t  rj1, rj2;

   rj1 = clock();
   rj2 = rj1;
   while(((double)(rj2-rj1)) / CLOCKS_PER_SEC < x)
        { rj2= clock(); }
}

/*LINUX
void freemem(p, nbytes)
void * *p; 
int nbytes;
{ free(*p); *p = NULL; }

void getmem(p, nbytes)
void * *p; 
int nbytes;
{ *p = malloc(nbytes); 
 (*fprintf(stderr," getmem de %d\n", nbytes);*)
 if(*p==NULL) fprintf(stderr,"NULO \n");
} */

void gotoxy(x, y)
unsigned char x; 
unsigned char y;

{  char X[3], Y[3];

  if(x > 9) {sprintf(X,"%2d",x);} else {sprintf(X,"%1d",x);}
  if(y > 9) {sprintf(Y,"%2d",y);} else {sprintf(Y,"%1d",y);}

  strcpy(gotoxy_str,"%c[");
  strcat(gotoxy_str,Y);
  strcat(gotoxy_str,";");
  strcat(gotoxy_str,X);
  strcat(gotoxy_str,"H");

  printf(gotoxy_str, 27);
  wherex = x;  wherey = y;
} 

void seek_c(f, r_size, nr)
FILE *f; 
int r_size; 
long int nr;
{ long int pos;

  pos = r_size * nr;
  fseek(f,pos,SEEK_SET);
}

void set_normalvideo() 
{ printf( "%c[0m", 27); 
  reversevideo = 0; }

void set_reversevideo()
{ printf( "%c[7m", 27); 
  reversevideo = 1; }

void str_c(x, format, len, s )
void *x; 
const char *format; 
int *len; 
char *s;
{ int i, j;
 
  /* Tipo varying de pascal tiene un 'int' al comienzo donde se guarda
     la longitud del string, por lo que el primer caracter del string esta
     en (dir(string) + 4)  
  */  

  *len = 0;
  *s = '\0';    /*  string nulo */

  for(i=0; ((format[i]!=0) && (format[i]!='%')); i++);
  if(format[i]) {
  for(j=i; ((format[j]!=0) && (format[j]!='d')); j++);
  if   (format[j]=='d')
       sprintf(s ,format, *((int *)x));   
  else {
  /* for(j=i; ((format[j]!=0) && (format[j]!='f')); j++); */
  /* merida*/ for(j=i; 
     ((format[j]!=0) && (format[j]!='f') && (format[j] !='e')); 
     j++);
  /*merida*/ if((format[j]=='f') || (format[j]=='e')) 
       sprintf(s,format, *((float *)x));
  else {
  for(j=i; ((format[j]!=0) && (format[j]!='l')); j++);
       if(format[j]=='l')
       sprintf(s,format, *((double *)x)); /* debe ser formato lf */
       } /*no f*/
       } /*no d*/
  /* computar longitud y colocarla para tipos varying de pascal */
  for(i = 0;  s[i] != 0; i++);
  *len = i  ;
  } /*no es formato*/
}

void val_c(s, x, tipo, codErr)
char *s; 
void *x; 
int tipo; 
int *codErr;
{  double y;
  long int z;
  char **ptr;

  *codErr = 0;
  errno = 0;
  ptr=&s;  /* Para dejar direccion de primer caracter invalido*/
  switch (tipo)
  { case 0: case 1: 
/*SUNOS 4.1 z = strtol(s,ptr,0); NO FUNCIONA -> */ z = atol(s); 
      /*z = strtol(s,ptr,0);*/
      if(tipo) *((long int *) x) = z;
    else       *((int      *) x) = z;
    break;
   
    case 2: case 3: 
/*SUNOS 4.1 y = strtod(s,ptr); NO FUNCIONA -> */ y = atol(s); 
      /*y = strtod(s,ptr);*/
      if(tipo==2) *((float  *) x) = y;
    else          *((double *) x) = y;
  }
/*  if (**ptr) errno=1;
  *codErr = errno;*/
if(errno) *codErr=errno;
}

unsigned char kbhit()
{ return(0); }

/*LINUX unsigned short; sun: unsigned int. Idem en GetDate*/
void GetTime(h,m,s,s100)
unsigned short *h,*m,*s,*s100;
{ struct tm *dat_time;
  time_t now;

  now=time(NULL);
  dat_time=localtime(&now);
  *h=(unsigned int)dat_time->tm_hour;
  *m=(unsigned int)dat_time->tm_min;
  *s=(unsigned int)dat_time->tm_sec;
  *s100=0;

}

void GetDate(y,m,d,wd)
unsigned short *y,*m,*d,*wd;
{ struct tm *dat_time;
  time_t today;

  today=time(NULL);
  dat_time=localtime(&today);
  *y=dat_time->tm_year;
  *m=dat_time->tm_mon;
  *d=dat_time->tm_mday;
  *wd=dat_time->tm_wday;

}
 
double _randreal()
{
 return(rand()/(double)(RAND_MAX));
}


/*end.*/


