/*LINUX graph.c  Ex-xgraph.c

  Lib xgraph: Emulacion de Lib Turbo Pascal GRAPH

  Version 1.0: Marta Sananes (San Diego State University, Universidad de Los Andes, 1996)
  Version 2.0: Rafael Tineo  (Universidad de Los Andes, 1997)
  Version 2.1: Marta Sananes (Universdidad de Los Andes, 1999)

  Version 3.0: Marta Sananes, colaboracion Solvey Maldonado 
               (No esta lista; Subventana)

  Ultima modificacion: MARTA 17.09.1999
  Ultima modificacion: MARTA 21.09.1999 (Lectura de caracteres Solvey)
  Ultima modificacion: MARTA 04.05.2000 (LINUX alpha)
  Ultima modificacion: MARTA 24.05.2000 (LINUX alpha)
*/

#include "graph.h"
#include <stdio.h>


char                *FONT[]={"courier","helvetica","times","lucida"};
int                  TextHigh,fill_style=0;

int                  VentanaActiva;  /* Deberia inicializarse al ejecutar InitGraph */
int                  NumVentanas;    /* Deberia inicializarse al ejecutar InitGraph */
int                  GraphResult=0;

Display             *display;    /* Se inicializa en InitGraph. */
int                  screen_num; /* Se inicializa en InitGraph. */
Screen              *scr_ptr;
XEvent               evento;
unsigned             long bg_pix,fg_pix,fill_pix;
unsigned int         bg_color,fg_color,fill_color;
GC                   NGC;
XGCValues            xgcvalues;
int                  curr_line_style = 0;                         
int                  curr_line_width = 1;
Font                 curr_font;
XFontStruct         *fontStruct;
word                 TextOrient=0;   /* 0 Horizontal y 1 Vertical */
Pixmap pixmap1 = 0;

Window               root;
Ventana              ventana[20];

XColor               colors[MAXCOLORS] = 
{{0,      0,       0,       0, DoRed | DoGreen | DoBlue}, /* 0: black       */
 {0,      0,       0,   65535, DoRed | DoGreen | DoBlue}, /* 1: blue        */
 {0,      0,   65535,       0, DoRed | DoGreen | DoBlue}, /* 2: green       */
 {0,      0,   51150,   51150, DoRed | DoGreen | DoBlue}, /* 3: cyan        */
 {0,  65535,       0,       0, DoRed | DoGreen | DoBlue}, /* 4: red         */
 {0,  40920,       0,   40920, DoRed | DoGreen | DoBlue}, /* 5: magenta     */
 {0,  40920,   10230,       0, DoRed | DoGreen | DoBlue}, /* 6: brown       */
 {0,  56265,   56265,   56265, DoRed | DoGreen | DoBlue}, /* 7: lightgray   */
 {0,  40920,   40920,   40920, DoRed | DoGreen | DoBlue}, /* 8: darkgray    */
 {0,      0,   30690,   65535, DoRed | DoGreen | DoBlue}, /* 9: lightblue   */
 {0,      0,   65535,   30690, DoRed | DoGreen | DoBlue}, /*10: lightgreen  */
 {0,      0,   65535,   65535, DoRed | DoGreen | DoBlue}, /*11: lightcyan   */
 {0,  65535,   40920,   40920, DoRed | DoGreen | DoBlue}, /*12: lightred    */
 {0,  65535,       0,   65535, DoRed | DoGreen | DoBlue}, /*13: lightmagenta*/
 {0,  65535,   65535,       0, DoRed | DoGreen | DoBlue}, /*14: yelow       */
 {0,  65535,   65535,   65535, DoRed | DoGreen | DoBlue}};/*15: white       */

Colormap             cmap;
XVisualInfo          vinfo_return;
int                  nvisual;
Visual               *visual;
Bool                 DisplayInexist = True;
unsigned short int   Monocromo=False;
XImage              *areaRotate=NULL,*areaRotate2=NULL;

XImage              *BuffIm=NULL;  /* Buffer que contiene el ultima area seleccionada. */
unsigned int         largo,alto;
Bool                 ImageStored = False;

unsigned int                  ancho_pant,alto_pant,depth;
/*LINUX*/

char MensContinue[256] = "Press any key to continue"; 

/* Prototipos de procedimientos internos

   void WaitForExpose()
   void SwapFillColor();
   word ColorNum(elPixel)
        unsigned long elPixel;
   void VerticalText(Texto,tPosX,tPosY);
   void VerticalText1(Texto,tPosX,tPosY)
        char *Texto;unsigned int tPosX;unsigned int tPosY;
   void VerticalText2(Texto)
        char *Texto;

 Fin Prototipos de procemientos internos*/

/* Procedimientos internos ************************************************************/

void WaitForExpose() { 
  XNextEvent(display,&evento); 
  while((evento.type != Expose) || 
        (evento.xexpose.window != ventana[NumVentanas].datvent)) {
    XNextEvent(display,&evento);
  }
}

unsigned int ColorNum(elPixel)
unsigned long elPixel;
{ 
  word i;
 
  for(i=0; colors[i].pixel!= elPixel; i++);
  return i;
}

void SwapFillColor() { 
  unsigned int elColor;

  XSetForeground(display,NGC,fill_pix);
  fill_pix=colors[fg_color].pixel;
  elColor=fg_color;
  fg_color=fill_color;
  fill_color=elColor;
  XFlush(display);
}

void VerticalText(Texto,tPosX,tPosY)
char *Texto;unsigned int tPosX;unsigned int tPosY;
{int x, y;
 unsigned int tWidth, tHigh;
 unsigned long punto;

 /*WaitForExpose(main_win);*/
 tWidth=XTextWidth(fontStruct,Texto,strlen(Texto));
 tHigh =TextHigh;
 areaRotate=XGetSubImage(display,ventana[VentanaActiva].datvent,
                      tPosX-tHigh,tPosY-tWidth, tWidth+tHigh,tWidth,
                      AllPlanes,ZPixmap,areaRotate,0,0);
/*PROB printf("VerticalText XClear \n"); getchar();*/
 XClearArea(display,ventana[VentanaActiva].datvent,tPosX,tPosY-tHigh, tWidth,tHigh,True);
/*PROB printf("VerticalText for \n"); getchar();*/
 for(x=tHigh; x<tWidth+tHigh; x++) {
    for(y=tWidth-tHigh; y<tWidth; y++) {
        punto=XGetPixel(areaRotate,x,y);
              XPutPixel(areaRotate,y-tWidth+tHigh, tWidth+tHigh-x,punto); } }
/*PROB printf("VerticalText end for \n"); getchar();*/
 XPutImage(display,ventana[VentanaActiva].datvent,NGC,areaRotate, 0,0,
           tPosX,tPosY-tWidth,tHigh,tWidth);
/*PROB  printf("VerticalText Put \n"); getchar();*/
 WaitForExpose(ventana[VentanaActiva].datvent);
/*PROB  printf("VerticalText sale \n"); getchar();*/
}            

void VerticalText1(Texto,tPosX,tPosY)
char *Texto;
unsigned int tPosX;
unsigned int tPosY;
{
  int x, y;
  unsigned int tWidth;
  unsigned long punto;

/*PROB*   printf("VerticalText1 TextHigh %d \n",TextHigh); getchar();*/
  tWidth=XTextWidth(fontStruct,Texto,strlen(Texto))+10;

  if (tPosY+tWidth>ventana[VentanaActiva].maxY) {
    tWidth=ventana[VentanaActiva].maxY-tPosY;
  }
  if (tPosX+TextHigh>ventana[VentanaActiva].maxX) {
    tPosX=ventana[VentanaActiva].maxX-TextHigh;
  }
/*PROB
if(pixmap1==0) {printf("pixmap1 es 0 \n"); getchar();}
else {printf("pixmap es %d \n",pixmap1);} */

  /*PROB if(pixmap1) {XFreePixmap(pixmap1);}*/
  pixmap1=XCreatePixmap(display,ventana[VentanaActiva].datvent,
                        tWidth,TextHigh,depth);
/*PROB  printf("VerticalText1 CreatePixmap \n"); getchar();*/
/*
  SetFillStyle(1,GetBkColor());
*/
  SwapFillColor();
  XFillRectangle(display,pixmap1,NGC,0,0,tWidth,TextHigh);
  XFlush(display);
  SwapFillColor();
  XDrawString(display,pixmap1,NGC,0,TextHigh,Texto,strlen(Texto));
  XFlush(display);
/*PROB  printf("VerticalText1 DrawString \n"); getchar();*/
  areaRotate=XGetImage(display,pixmap1,0,0,tWidth,TextHigh,
	               AllPlanes,ZPixmap);
  areaRotate2=XGetImage(display,ventana[VentanaActiva].datvent,
                        0,0,TextHigh,tWidth,AllPlanes,ZPixmap);
/*PROB  printf("VerticalText1 GetImage\n"); getchar();*/
  for(x=0; x<tWidth; x++) {
    for(y=0; y<TextHigh; y++) {
      punto=XGetPixel(areaRotate,x,y);
      XPutPixel(areaRotate2,y,tWidth-x,punto); 
 /*   XPutPixel(areaRotate,y,tWidth-x,punto); */
    } 
  } 
/*PROB  printf("VerticalText1 for \n"); getchar();*/
  XPutImage(display,ventana[VentanaActiva].datvent,NGC,areaRotate2,0,0,
            tPosX,tPosY,TextHigh,tWidth);
/*XPutImage(display,ventana[VentanaActiva].datvent,NGC,areaRotate,0,0,
            tPosX,tPosY,TextHigh,tWidth);*/
  XFlush(display);
  XDestroyImage(areaRotate);
  XDestroyImage(areaRotate2);
  
  areaRotate=NULL;
  areaRotate2=NULL;
  
  /*XFreePixmap(pixmap1);  pixmap1=0;*/
/*PROB printf("VerticalText1 Destroy\n"); getchar();*/
}

void VerticalText2(Texto)
char *Texto;
{
  int i=0;
  unsigned int x,y;
  char car[2];

  car[1]=0;
  x=ventana[VentanaActiva].msXWhereX;
/*PROB y=ventana[VentanaActiva].msXWhereY-((strlen(Texto)-1)*TextHigh)+2;*/
  y=ventana[VentanaActiva].msXWhereY;
  while (Texto[i]) {
    car[0]=Texto[i];
    XDrawString(display,ventana[VentanaActiva].datvent,NGC,x,y,car,1);
    y+=TextHigh+2;
    i++;
  }
  ventana[VentanaActiva].msXWhereY=y-TextHigh-2;
  ventana[VentanaActiva].msXWhereX=x+XTextWidth(fontStruct,car,1);
  XFlush(display);
}

/* Chequea en cada ventana si se produjo un evento de raton
   Devuelve el numero de la ventana donde ocurrio el evento, las coordenadas y el
   boton pulsado del raton (x,y,b). Si no se produjo evento de raton en ninguna
   ventana devuelve -1. */

int chequear_raton(x,y,b,tipev)
int *x;
int *y;
int *b;
int *tipev;
{
  int i;

  for (i=0;i<NumVentanas;i++) {
    if (XCheckWindowEvent(display,ventana[i].datvent,ButtonPressMask,&evento)==True) {
      *x=evento.xbutton.x;
      *y=evento.xbutton.y;
      *b=evento.xbutton.button;
      *tipev=1;
      return i;
    } else {
      if (XCheckWindowEvent(display,ventana[i].datvent,ButtonReleaseMask,&evento)==True) {
        *x=evento.xbutton.x;
        *y=evento.xbutton.y;
        *b=evento.xbutton.button;
        *tipev=2;
        return i;
      } else {
        if (XCheckWindowEvent(display,ventana[i].datvent,ButtonMotionMask,&evento)==True) {
          *x=evento.xbutton.x;
          *y=evento.xbutton.y;
          *b=evento.xbutton.button;
          *tipev=3;
          return i;
        }
      }
    }
  }
 return -1;
}


/* Chequea en cada ventana si se produjo un evento del teclado. Se devuelve el
   numero de la ventana donde ocurrio el evento y la tecla que fue pulsada a
   traves del parametro t. Si no se prudujo evento en ninguna ventana se devuelve
   el valor -1 */

int chequear_teclado(t)
int *t;
{
  int i;

  for (i=0;i<NumVentanas;i++) {
    if (XCheckWindowEvent(display,ventana[i].datvent,KeyPressMask,&evento)==True) {
      *t=evento.xkey.keycode;
      return i;
    }
  }
  return -1;
}
/* Chequea en cada ventana si se produjo un evento de cambio de visibilidad. Se
   devuelve el numero de la ventana donde se produjo el evento y el tipo de
   visibilidad registrada a traves del parametro estado. Los tipos de visibilidad
   son: 0- Totalmente visible, 1- Parcialmente visible y 2- Oculta. Si no se
   registra cambio en la visibilidad de ninguna ventana se devuelve el valor -1. */

int visibilidad(estado)
int *estado;
{
  int i;

  for (i=0;i<NumVentanas;i++) {
    if (XCheckWindowEvent(display,ventana[i].datvent,VisibilityChangeMask,&evento)==True) {
      *estado=evento.xvisibility.state;
      return i;
    }
    if (XCheckWindowEvent(display,ventana[i].datvent,ExposureMask,&evento)==True) {
      *estado=evento.xvisibility.state;
      return i;
    }
  }
  return -1;
}


/* Fin Procedimientos internos ******************************************************/

/* Para Inicio y Finalizacion de sesion modo grafico */

void  InitGraph(gd,gm,ptdr)
/*MARTA 17.09.1999 En LINUX se deja como estaba */
/*MARTA 24.0r59.2000 Se pone short por campatibilidad con p2c */
short *gd;
short *gm;

char *ptdr;
{
  int i;

/*puts("InitGraph \n"); getchar();*/
  if (DisplayInexist) {
    if ((display=XOpenDisplay(NULL))==NULL) {
      printf("Can't connect to display\n");
      getchar();
      exit(-1);
    }

/* Marta 06.98 Cambio de lugar */
  VentanaActiva=-1;
  NumVentanas=0;
    
    screen_num=XDefaultScreen(display);
    depth=DefaultDepth(display,screen_num);
    scr_ptr=DefaultScreenOfDisplay(display);
    ancho_pant=DisplayWidth(display,screen_num);
    alto_pant=DisplayHeight(display,screen_num);

/* marta 21.07.00*/
/*
printf("screen_num: %d \n",screen_num);
printf("depth: %d \n",depth);
printf("ancho: %d \n",ancho_pant);
printf("alto: %d \n",alto_pant);*/
/*DELL 9,8,00*/
visual = DefaultVisualOfScreen(scr_ptr);    
vinfo_return.visual=visual;
/*fin DEll
printf("Class: %d \n",visual->class);
printf("Colormap: %d \n",visual->map_entries);
printf("VisualID: %d \n",visual->visualid);*/
/*DELL 9.8.00
XGetVisualInfo(display,511,&vinfo_return,&nvisual);
printf("nvisual: %d \n",nvisual);

if (!nvisual) {puts("unknown visual \n"); exit(-1);}

XMatchVisualInfo(display,screen_num,8,PseudoColor,&vinfo_return)
*/
if(
XMatchVisualInfo(display,screen_num,depth,visual->class,&vinfo_return)
==False) { puts("No Match Visual Info \n"); getchar(); exit(-1);}
/*printf("VisualID: %d \n",vinfo_return.visualid);
printf("visual: %d \n",vinfo_return.visual);
printf("Class: %d \n",vinfo_return.class);
printf("Colormap: %d \n",vinfo_return.colormap_size);
puts("Sale de XMatchVisualInfo...\n"); */
/*    ==False) { 
      Monocromo=True;
    }*/
    cmap=DefaultColormap(display,screen_num);
    for (i=0;i<MAXCOLORS;i++) {
      /*DELL 9.8.00 XAllocColor(display,cmap,(XColor *)&colors[i].pixel);*/
      XAllocColor(display,cmap,&colors[i]);
    }
    DisplayInexist=False;
    root=DefaultRootWindow(display);
    fg_pix=WhitePixel(display,screen_num);
    bg_pix=BlackPixel(display,screen_num);
    fill_pix=fg_pix;
    bg_color=ColorNum(bg_pix);
    fg_color=ColorNum(fg_pix);
    fill_color=fg_color; 
    NGC=XCreateGC(display,root,0,0);
    xgcvalues.fill_style=FillSolid;
    XChangeGC(display,NGC,GCFillStyle,&xgcvalues); 
    XSetForeground(display,NGC,fg_pix);
    XSetLineAttributes(display,NGC,curr_line_width,curr_line_style,0,0);
    XSetFunction(display,NGC,GXcopy); 
    /*MARTA 17.09.1999*/ 
    InitWindow(*gd,*gm,ptdr);
    /*InitWindow(gd,gm,ptdr);*/
    fontStruct =XLoadQueryFont(display,"-adobe-helvetica-medium-r-normal--12-*-*-*-*-*-ISO8859-1");
    TextHigh=12;
    if(fontStruct==NULL) {
      fontStruct=XLoadQueryFont(display,"fixed");
    }
    curr_font=fontStruct->fid;
    XSetFont(display,NGC,curr_font); 
  }
/*Display exists, create new window MS 31.05.98 */
  /*MARTA 17.09.1999*/
 else InitWindow(*gd,*gm,ptdr);
  /*else InitWindow(gd,gm,ptdr);*/
/*PROB*  printf("TextHigh %d \n",TextHigh); getchar();*/
/*puts("Sale InitGraph "); */
}

void CloseGraph() {
  if (BuffIm!=NULL) {
    XDestroyImage(BuffIm);
  }
  XUnloadFont(display,curr_font);
  XFreeColormap(display,cmap);
  XCloseDisplay(display);
  DisplayInexist=True;
}



/* Procedimientos desarrollados por Rafael Tineo desde el Lunes 27-01-97 */ 

/* Crea una ventana */

int InitWindow(largo,alto,namewindow)
/*LINUX 24.05.200 Se pone short por compatibilidad con p2c*/
short largo;
short alto;
char *namewindow;
{
/*PROB*/ int Largo, Alto;
Largo=largo; Alto=alto;

/*puts("Entra a InitWindow "); */
  /*MARTA 21.09.1999 if (NumVentanas<MaxWindows) {*/
  if ((DisplayInexist==False) && (NumVentanas<MaxWindows)) {
/*DELL 9.8.00    ventana[NumVentanas].datvent=XCreateSimpleWindow(display,root,100,100,Largo,*/
    ventana[NumVentanas].datvent=XCreateSimpleWindow(display,root,10,10,Largo,
                                 Alto,2,fg_pix,bg_pix);
                                 /*alto,5,bg_pix,bg_pix,fg_pix);*/
    ventana[NumVentanas].abierta=VAbierta;
    ventana[NumVentanas].visible=VVisible;
    ventana[NumVentanas].msXWhereX=0;
    ventana[NumVentanas].msXWhereY=0;
    ventana[NumVentanas].maxX=largo-1;
    ventana[NumVentanas].maxY=alto-1;
    XSetWindowColormap(display,ventana[NumVentanas].datvent,cmap);
    XSelectInput(display,ventana[NumVentanas].datvent,ButtonPressMask|
                 ExposureMask
                 /*DELL |ResizeRedirectMask*/
                 |VisibilityChangeMask|
                 KeyPressMask|ButtonReleaseMask|ButtonMotionMask);
    XStringListToTextProperty(&namewindow,1,&ventana[NumVentanas].TextProp);
    XSetWMName(display,ventana[NumVentanas].datvent,&ventana[NumVentanas].TextProp);
    XMapWindow(display,ventana[NumVentanas].datvent);   
    WaitForExpose();/* Repuesto 12.9.2000*/
    XFlush(display);
/*LINUX 12.9.2000*/ delay(0.1);
/* Marta 05.06.98*/ VentanaActiva=NumVentanas;
    NumVentanas++;
/* Marta 05.06.98
    if (VentanaActiva==-1) {
      VentanaActiva=0;
    } */
    GraphResult=0;      /* No hubo error en la operacion */
    return NumVentanas-1;
  }
  GraphResult=1;        /* Hubo error en la operacion */ 
  return -1;
}

/* Destruye la ventana indicada por el parametro aWin */

/*MARTA 21.09.1999 void CloseWindow(man)*/
void CloseWindow(aWin)
int aWin;
{
  if ((aWin>=0) && (aWin<NumVentanas)) {
    if (ventana[aWin].abierta) {
      XDestroyWindow(display,ventana[aWin].datvent);
      ventana[aWin].abierta=0;
      GraphResult=0;
    } else {
      GraphResult=1;
    }
  } else {
    GraphResult=1;
  }
}

/* Selecciona como ventana activa a la ventana marcada con aWin */

void SelectWindow(aWin)
int aWin;
{
/*printf("SelectWindow: ventana %d \n",aWin); getchar();*/
  if ((aWin>=0) && (aWin<NumVentanas)) {
    if (ventana[aWin].abierta) {
      VentanaActiva=aWin;
      GraphResult=0;
    } else {
      GraphResult=1;
    }
  } else {
    GraphResult=0;
  }
/*printf("Result %d \n",GraphResult); getchar();*/
}

/* Limpia la ventana activa */

void ClearDevice() {
/*puts("Entra ClearDevice "); */
  if (VentanaActiva!=-1) {
    ventana[VentanaActiva].msXWhereX=0;
    ventana[VentanaActiva].msXWhereY=0;
    XClearWindow(display,ventana[VentanaActiva].datvent);
/*puts("Sale XClearWindow"); */
    XFlush(display);
/*puts("Sale XFlush"); */
    GraphResult=0;
  } else {
    GraphResult=1;
  }
/*puts("Sale ClearDevice"); */
}

/* Selecciona el tipo de cursar a usar para la ventana activa */

/*MARTA 21.09.1999 void SetMouseCursor(tipo)*/
void SetMouseCursor(CursorType)
unsigned int CursorType;
{
  ventana[VentanaActiva].vcursor=XCreateFontCursor(display,CursorType);
  XDefineCursor(display,ventana[VentanaActiva].datvent,ventana[VentanaActiva].vcursor);
  XFlush(display);
}


/* Funciones para manipular eventos. */


/* Almacena en la estructura de eventos el ultimo evento ocurrido 
   Con el parametro tipo: 1- visibilidad, 2 - teclado, 3- raton,  
   se indica el tipo de evento que se esta buscando. */

/*MARTA 21.09.1999 void ThisEvent(tipo,datev)*/
void ThisEvent(EventType,EventData)
int EventType;
EventStructure *EventData;
{
/*MARTA 17.09.1999 Devuelve en nv numero de ventana (c) + 1; */
  if (EventType==1) {
    EventData->aWin=visibilidad(&EventData->tv)+1;
  }
  if (EventType==2) {
    EventData->aWin=chequear_teclado(&EventData->k)+1;
  }
  if (EventType==3) {
    EventData->aWin=chequear_raton(&EventData->x,&EventData->y,&EventData->b,&EventData->me)+1;
  }
}


/* Rutina que verifica si se ha producido un evento de cualquier tipo 
   (1- Visibilidad, 2- Teclado, 3- Raton) en cualquier ventana.
   Si no se produjo ningun evento el atribujo "nv" de la estructura de
   eventos suministrada valdra -1. */

/*MARTA 21.09.1999 int NextEvent(tipo,datev)*/
void NextEvent(EventType,EventData)
int *EventType;
EventStructure *EventData;
{
/*MARTA 17.09.1999 No hay ventanas ahora queda en 0 (Pascal), no -1 (c) */
  int i=1;
  char seguir=1;
/*MARTA21.09.1999 comienza */ 
 while (seguir)
 { i = 1;
  /*MARTA fin 21.09.1999 while ((i<=3) && (seguir)) {*/
  while (i<=3) {
    ThisEvent(i,EventData);
    /*MARTA 17.09.1999 if (datev->nv!=-1) {*/
    if (EventData->aWin) { seguir=0; *EventType=i; i=4; }
    i++;
  }
 }
}


/* Funciones de Informacion general */


/* Devuelve un numero maximo de colores que tiene la paleta */

unsigned int GetMaxColor() {  
  return (MAXCOLORS-1);
}

/* Devuelve en Valor Maximo del eje X de la ventana activa */

unsigned int  GetMaxX() { 
  return ventana[VentanaActiva].maxX;
}

/* Devuelve en Valor Maximo del eje Y de la ventana activa */

unsigned int  GetMaxY() {
  return ventana[VentanaActiva].maxY;
}

/* Retorna el numero de color de fondo activo */

word GetBkColor() { 
  return bg_color; 
}

/* Retorna el numero de color de trazo activo */

word GetColor() { 
  return fg_color; 
}


/* Funciones de trazado */

/* Seleccion del tipo de linea a usarse */

void SetLineStyle(LineStyle, pattern, Thickness)
word LineStyle; 
word pattern; 
word Thickness;
{    
  XSetLineAttributes(display,NGC,Thickness,LineStyle,0,0); 
  curr_line_width=Thickness;    
  curr_line_style=LineStyle;  
    if ((pattern>=0) && (pattern<=3)) {
    fill_style=pattern;
  }
}

/* Dibuja una linea en la ventana activa entre los puntos (x1,y1) y (x2,y2) */

void Line(x1, y1, x2, y2)
int x1; int y1; int x2; int y2;
{
  ventana[VentanaActiva].msXWhereX=x2;   
  ventana[VentanaActiva].msXWhereY=y2;  /*cursor grafico invisible*/
  XSetFillStyle(display,NGC,fill_style);
  XDrawLine(display,ventana[VentanaActiva].datvent,NGC,x1,y1,x2,y2);
  XSetFillStyle(display,NGC,0);
  XFlush(display);
} /*Line*/

/* Dibuja una linea desde la posicion relativa actual del cursor hasta el punto
   (dx,dy) suministrado como parametro */

void LineRel(dx, dy)
int dx; int dy;
{ 
  unsigned int cx, cy;

  cx=ventana[VentanaActiva].msXWhereX;
  cy=ventana[VentanaActiva].msXWhereY;
  Line(cx,cy,cx+dx,cy+dy);
} /*LineRel*/

/* Dibuja una linea desde la posicion actual del cursor hasta la posicion
   (x,y) suministrada como parametro */

void LineTo(x, y)
int x; int y;
{
  Line(ventana[VentanaActiva].msXWhereX,ventana[VentanaActiva].msXWhereY,x,y);
} /*LineTo*/

/* Dibuja un punto en la coordenada (x,y) de la ventana activa. */

void PutPixel(x, y, Pixel)
int x; int y; word Pixel;
{
  ventana[VentanaActiva].msXWhereX=x;
  ventana[VentanaActiva].msXWhereY=y; /*cursor grafico invisible*/
  XDrawPoint(display,ventana[VentanaActiva].datvent,NGC,x,y);
  XFlush(display);
} /*PutPixel*/

/* Funcion que dibuja un rectangulo en la ventana activa con esquina superior 
   izquierda (x1,y1) y esquina inferior derecha (x2,y2) */

void Rectangle(x1, y1, x2, y2)
int x1; int y1; int x2; int y2;
{
/*PROB*  printf("TextHigh %d \n",TextHigh); getchar();*/
  ventana[VentanaActiva].msXWhereX=x1;   
  ventana[VentanaActiva].msXWhereY=y1; 
  XDrawRectangle(display,ventana[VentanaActiva].datvent,NGC,x1,y1,x2-x1,y2-y1);
  XFlush(display);
} /*Rectangle*/

/* Dibuja un rectangulo relleno en la ventana activa con esquina superior
   izquiera (x1,y1) y esquina inferior derecha (x2,y2) */

void Bar(x1, y1, x2, y2)
int x1; int y1; int x2; int y2;
{
  ventana[VentanaActiva].msXWhereX=x1;
  ventana[VentanaActiva].msXWhereY=y1;   

  SwapFillColor();
  XSetFillStyle(display,NGC,fill_style);
  XFillRectangle(display,ventana[VentanaActiva].datvent,NGC,x1,y1,x2-x1,y2-y1);
  XFlush(display);
  SwapFillColor();
  XSetFillStyle(display,NGC,0);
  XFlush(display);
} /*Bar*/

/* Dibuja un arco con centro (x,y), radio (radius), angulo inicial StAngle y
   angulo final EndAngle */

void Arc(x, y, StAngle, EndAngle, radius)
int x; 
int y; 
unsigned int StAngle; 
unsigned int EndAngle; 
unsigned int radius;
{ 
  ventana[VentanaActiva].msXWhereX=x;
  ventana[VentanaActiva].msXWhereY=y;   
  XDrawArc(display,ventana[VentanaActiva].datvent,NGC,x,y,radius,radius,64*StAngle,64*EndAngle);
  XFlush(display);
} /*Arc*/

/* Dibuja un circulo con centro (x,i) y radio "radius" */

void Circle(x, y, radius)
int x; 
int y; 
unsigned int radius;
{    
  ventana[VentanaActiva].msXWhereX=x;
  ventana[VentanaActiva].msXWhereY=y;   
  XDrawArc(display,ventana[VentanaActiva].datvent,NGC,x,y,radius,radius,0,64*360);
  XFlush(display);
} /*Circle*/


/* Funciones  de eleccion de  colores y seleccion de la posicion del cursor */


/* Seleccion del color de fondo */

void SetBkColor(ColorNum)
unsigned int ColorNum;
{   
  if(Monocromo) {
    ColorNum=0; 
  }
  XSetWindowBackground(display,ventana[VentanaActiva].datvent,colors[ColorNum].pixel); 
  bg_color=ColorNum;
  XFlush(display); 
}

/* Seleccion del color de fondo */

void SetColor(Color)
unsigned int Color;
{   
  if (Monocromo) {
    if (Color) {
      Color=15; 
    }
  }
  XSetForeground(display,NGC,colors[Color].pixel); 
  fg_color=Color;
  XFlush(display); 
}

void SetFillStyle(Pattern, Color)
word Pattern;
word Color;
{
  fill_pix=colors[Color].pixel;
  fill_color=Color;
  if ((Pattern>=0) && (Pattern<=3)) {
    fill_style=Pattern;
  }
}

/* Funcion que mueve la posicion del cursor (dx,dy) respecto a su posicion 
   actual */

void MoveRel(dx, dy)
int dx; int dy;
{ 
  ventana[VentanaActiva].msXWhereX+=dx;
  ventana[VentanaActiva].msXWhereY+=dy;
}

/* Funcion que mueve la posicion del cursor al punto (x,y) */

void MoveTo(x, y)
int x; int y;
{ 
  ventana[VentanaActiva].msXWhereX=x;     
  ventana[VentanaActiva].msXWhereY=y; 
}


/* Funciones de Manejo de texto */

void OutText(Texto) 
char *Texto; /*Diferencia con pascal: usar conversion string-char* */
{
  if (TextOrient==2) {
    VerticalText2(Texto);
  } else {
    if(TextOrient) {
/*MARTA: Segmentation Fault*/
      VerticalText2(Texto,ventana[VentanaActiva].msXWhereX,ventana[VentanaActiva].msXWhereY);
/*
      VerticalText1(Texto,ventana[VentanaActiva].msXWhereX,ventana[VentanaActiva].msXWhereY);
      ventana[VentanaActiva].msXWhereX=ventana[VentanaActiva].msXWhereX+TextHigh; 
*/
    } else {
      XDrawString(display,ventana[VentanaActiva].datvent,NGC,
		  ventana[VentanaActiva].msXWhereX,
		  ventana[VentanaActiva].msXWhereY,Texto,strlen(Texto));
      XFlush(display);
      ventana[VentanaActiva].msXWhereX+=XTextWidth(fontStruct,Texto,strlen(Texto));
    }
  }
/*PROB*  printf("TextHigh %d \n",TextHigh); getchar();*/
} /*OutText*/

void OutTextXY(x, y, Texto) 
int x; int y; char *Texto; /*Diferencia con pascal: idem */
{
/*PROB
printf("Ventana Activa %d \n",VentanaActiva); 
printf("Numero Ventanas%d \n",NumVentanas); getchar();
*/
  if ((x<ventana[VentanaActiva].maxX) && (y<ventana[VentanaActiva].maxY)) { 
    ventana[VentanaActiva].msXWhereX=x;
    ventana[VentanaActiva].msXWhereY=y;
    OutText(Texto);
  }
} /*OutTextXY*/

void SetTextStyle(tipoFont, Direction, CharSize)
word tipoFont;
word Direction;
word CharSize;
{ 
  char cadena[100];
  int tam;
  
  if (tipoFont>3) {
    tipoFont=0;
  }
  tam=(int)CharSize;
  XFreeFont(display,fontStruct);
  sprintf(cadena,"-adobe-%s-medium-r-normal--%i-*-*-*-*-*-ISO8859-1",FONT[tipoFont],tam);
  fontStruct =XLoadQueryFont(display,cadena);
  if(fontStruct==NULL) {
      fontStruct=XLoadQueryFont(display,"fixed");
    }
  curr_font=fontStruct->fid;
  XSetFont(display,NGC,curr_font);
  TextOrient=Direction;
  TextHigh=CharSize;
/*MARTA 05.05.2000*/ if(!TextHigh) TextHigh=12;
}


void SetTextJustify(Horiz, vert)
word Horiz; 
word vert;
{ }


/* Rutinas para manejo de imagenes. */


void PutImage(x1,y1,pi,BitBlt)
int x1;
int y1;
void *pi;
word BitBlt;
{
  if (ImageStored==True) {  

    if (x1+largo>ventana[VentanaActiva].maxX) {
      largo=ventana[VentanaActiva].maxX-x1;
    }
    if (y1+alto>ventana[VentanaActiva].maxY) {
      alto=ventana[VentanaActiva].maxY-y1;
    }

    XPutImage(display,ventana[VentanaActiva].datvent,NGC,BuffIm,0,0,
              x1,y1,largo,alto);
  }
}

void GetImage(x1,y1,x2,y2,pi)
int x1;
int y1;
int x2;
int y2;
void *pi;
{
  largo=x2-x1;
  alto=y2-y1;
  if (BuffIm!=NULL) {
    XDestroyImage(BuffIm);
    BuffIm=NULL; 
  }

  if (x1+largo>ventana[VentanaActiva].maxX) {
    largo=ventana[VentanaActiva].maxX-x1;
  }
  if (y1+alto>ventana[VentanaActiva].maxY) {
    alto=ventana[VentanaActiva].maxY-y1;
  }

  BuffIm=XGetImage(display,ventana[VentanaActiva].datvent,x1,y1,largo,alto,
	           AllPlanes,ZPixmap);
  ImageStored = True;
}

/* Solvey Maldonado ****************************************************/
/* Procedimiento que devuelve el numero de la ventana activa (17-7-98) */

int GetActiveWindow()
{
  int i;

  if (ventana[VentanaActiva].abierta) {
      GraphResult=0;
      return (VentanaActiva+1); /*MARTA 21.09.1999 +1*/
    } else {
      GraphResult=1;
      return(0); /*MARTA 21.09.1999*/
    }
}

/* Procedimiento que devuelve el numero de la ultima ventana creada (17-7-98) */

int GetLastWindow()
{
  int i;

  if (ventana[NumVentanas-1].abierta) {
      GraphResult=0;
      /*MARTA 21.09.1999 return (ventana[NumVentanas-1].datvent);*/
      return (NumVentanas);
    } else {
      GraphResult=1;
      return(0);   /*MARTA 21.09.1999*/
    }
}
/*Solvey fin */

/*MARTA LINUX*/
void PauseGraphic()
{
  EventStructure Evento;
  SetTextStyle(0, 0, 16);
  OutTextXY(140, 20, MensContinue);
  do {
    ThisEvent(2, &Evento);
  } while (Evento.aWin - 1 != VentanaActiva);
 
  SetTextStyle(0, 0, 0);
}                 

