/*graph.h  Ex-xgraph.h

  Lib xgraph: Emulacion de Lib Turbo Pascal GRAPH

  Primera version: Marta Sananes
  Segunda version: Rafael Tineo
  Agregado segunda version: Solvey Maldonado

  Ultima modificacion: MARTA 17.09.1999
  Ultima modificacion: MARTA 21.09.1999 (Lectura de caracteres Solvey)
  Ultima modificacion: MARTA 04.05.2000 (LINUX alpha)
*/

#include <X11/Xlib.h>
#include <X11/X.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
/*AGRE 21.09.1999*/
#include <X11/keysym.h>

#ifndef CTIPOS
#include "ctipos.h"
#endif


/* Constantes de la libreria xgraph */

#define MaxWindows 20
#define MAXCOLORS  16
#define VAbierta    1
#define VVisible    1

  /* Los colores */

#define  BLACK          0
#define  BLUE           1
#define  GREEN          2
#define  CYAN           3
#define  RED            4
#define  MAGENTA        5
#define  BROWN          6
#define  LIGHTGRAY      7
#define  DARKGRAY       8
#define  LIGHTBLUE      9
#define  LIGHTGREEN    10
#define  LIGHTCYAN     11
#define  LIGHTRED      12
#define  LIGHTMAGENTA  13
#define  YELLOW        14
#define  WHITE         15
 
  /* Los tipos de linea */
  
#define  SolidLn     0
#define  DottedLn    2  /*no hay correspondiente*/
#define  CenterLn    2  /*idem*/
#define  DashedLn    1
#define  UserBitLn   0  /*no hay correspondiente*/
#define  NormWidth   1
#define  ThickWidth  3

  /* Los tipos de ajuste */

#define  LeftText    0
#define  CenterText  1
#define  RightText   2
#define  BottomText  0
#define  TopText     1

  /* Los tipos de orientacion */

#define  HorizDir  0
#define  VertDir   1

  /* Los tipos de Fonts */

#define  DefaultFont    0
#define  TriplexFont    1
#define  SmallFont      2
#define  SansSerifFont  3
#define  GothicFont     4

  /* Patrones de relleno */

#define  FillSolid           0    /* Hay diferencia en los patrones de */
#define  FillTiled           1    /* relleno con respecto al TURBO pascal */
#define  FillStippled        2
#define  FillOpaqueStippled  3

 /* Tipos de evento */

#define  VisibilityEvent  1
#define  KeyboardEvent    2
#define  MouseEvent       3  

/* Tipos de visibilidad */
  
#define  TotalVisibility    0
#define  PartialVisibility  1
#define  NoVisibility       2

/* Tipos de evento de raton */
  
#define  ButtonDown    1
#define  ButtonUp      2
#define  ButtonMotion  3

/* Tipos de cursor para raton */

#define  target    128
#define  tcross    130
#define  left_ptr  132
#define  watch     150
#define  xterm     152


typedef struct Estructura_Eventos {
  int aWin;    /* Ex-nv Ventana en que ocurrio el evento. */
  int x;     /* Coordenada x del raton. */         
  int y;     /* Coordenada y del raton. */
  int b;     /* Numero del boton del raton presionado. */
  int k;     /* Ex-t tecla presionada. */
  int tv;    /* tipo de visibilidad registrado. */
  int me;  /* Tipo de evento de raton registrado */
} EventStructure; /*MARTA 21.09.1999 cambio nombres (nv, t) */


typedef struct Estructura_Ventana {
  Window datvent;
  int abierta;
  int visible;
  unsigned int msXWhereX;
  unsigned int msXWhereY;
  unsigned int maxX;
  unsigned int maxY;
  XTextProperty *TextProp;
  Cursor vcursor;
} Ventana;

  
void InitGraph();

void CloseGraph();

int InitWindow();

void CloseWindow();

void SelectWindow();

void ClearDevice();

void ThisEvent();

/*MARTA 21.09.1999 int NextEvent();*/
void NextEvent();

void Line();

void LineRel();

void LineTo();

void SetBkColor();

void SetColor();

void SetFillStyle();

void MoveRel();

void MoveTo();

void PutPixel();

void Rectangle();

unsigned int GetMaxColor();

unsigned int GetMaxX();

unsigned int GetMaxY();

void OutText();

void OutTextXY();

void SetLineStyle();

void SetMouseCursor();

void SetTextStyle();

void SetTextJustify();

word GetBkColor();

word GetColor();

void GetImage();

void PutImage();

/*Solvey Maldonado */

int GetActiveWindow();

int GetLastWindow();

void PauseGraphic();

